    9142
"	VERSION 3.20			Copyright(C) 1988-1989 Data I/O Corp.
"==============================================================================
" constant.inc
"
Z,C,K,X,U,D,P,H,L = .Z., .C., .K., .X., .U., .D., .P., 1, 0;
TRUE, FALSE = !0, 0;


" E0320.INC

	MISER macro (a) { fuses [2912,2913] = [?a,?a]; };

	TURBO macro (a) { fuses [2914,2915] = [?a,?a]; };


" E0600.INC

	TURBO macro (a) { fuses [6480,6481] = [?a,?a]; };


" E0900.INC

	TURBO macro (a) { fuses [17400,17401] = [?a,?a]; };


" E1210.INC
" Clock modes 0,1,2,3 and 4 are supported by the 3.00 SIMULATOR.
"
" The input latches are not modeled in modes 6 and 7.
"
" The output clock polarity is reversed in modes 5 and 7, this
" will not cause any problems if the .C. and .K. are used.
" Clocking with decrete '0's and '1's may produce simulation
" errors.

	CLK_MODE macro (a) { fuses [15144,15143,15142] = ?a;};

	TURBO macro (a) { fuses [15145,15146] = [?a,?a]; };


" E1800.INC

	MISER_CLK_C macro (a) { fuses 42480 = ?a; };
	MISER_CLK_B macro (a) { fuses 42481 = ?a; };
	MISER_CLK_A macro (a) { fuses 42482 = ?a; };
	MISER_CLK_D macro (a) { fuses 42483 = ?a; };
	MISER_IN_C  macro (a) { fuses 42484 = ?a; };
	MISER_IN_B  macro (a) { fuses 42485 = ?a; };
	MISER_IN_A  macro (a) { fuses 42486 = ?a; };
	MISER_IN_D  macro (a) { fuses 42487 = ?a; };

	TURBO macro (a) { fuses [42488,42489] = [?a,?a]; };


" F155.INC

	EA_HIZ macro  { fuses [2106,2107] = [1,1]; };
	EB_HIZ macro  { fuses [2104,2105] = [1,1]; };


" F157.INC

	EA_HIZ macro  { fuses [2106,2107] = [1,1]; };
	EB_HIZ macro  { fuses [2104,2105] = [1,1]; };


" F159.INC

	EA_HIZ macro  { fuses [2104,2105] = [1,1]; };
	EB_HIZ macro  { fuses [2106,2107] = [1,1]; };


" F179.INC

	EA_HIZ macro  { fuses [2450,2451] = [1,1]; };
	EB_HIZ macro  { fuses [2448,2449] = [1,1]; };

" F6001.INC

	"Input Logic Macro Cell Configuration for F6001
	" (1,1) Async Input   (default)
	" (1,0) Registered Input
	" (0,0) Latched Input
	ILMC  macro (LATCH,SYN) { FUSES [8219,8218] = [?LATCH,?SYN]; }
	IOLMC macro (LATCH,SYN) { FUSES [8221,8220] = [?LATCH,?SYN]; }

SIGNATURE MACRO (string)
{
   @CONST cnt = 1;
   @CONST r1 = 8222;	" First address of signature word
   @IRPC A (?string)
   {
	@IF (cnt > 9) { @MESSAGE 'WORD TOO LONG'; @EXIT;}
   	FUSES [@EXPR r1;..@EXPR (r1+7);] = @EXPR '?A';;
	@CONST  r1 = r1 + 8;
	@CONST	cnt = cnt + 1;
   }
}

" P16X4.INC
	"These macros are used to create a JEDEC file for the
	"arithmetic PALs such as the 16X4 and 16A4. Valid test
	"vectors can be generated for the device programmer 
	"but ABEL can not simulate these equations.

	"Reduction level -r0 must always be used.

	"Fixed symbol macros
	A          macro (n) { A?n & !A?n};		" (A)
	NA         macro (n) { B?n & !B?n};		" (/A)
	B          macro (n) { B?n &  A?n};		" (B)
	NB         macro (n) {!B?n & !A?n};		" (/B)

	A_OR_B     macro (n) { A?n};			" (A+B)
	NA_OR_B    macro (n) { B?n};			" (/A+B)
	N_OR_NB    macro (n) {!A?n};			" (A+/B)
	NA_OR_NB   macro (n) {!B?n};			" (/A+/B)

	A_AND_B    macro (n) { B?n &  A?n & !A?n};	" (A*B)
	NA_AND_B   macro (n) { B?n & !B?n &  A?n};	" (/A*B)
	A_AND_NB   macro (n) {!B?n &  A?n & !A?n};	" (A*/B)
	NA_AND_NB  macro (n) { B?n & !B?n & !A?n};	" (/A*/B)

	A_XNOR_B   macro (n) { B?n & !A?n}; 		" (A:*:B)
	A_XOR_B    macro (n) {!B?n &  A?n};		" (A:+:B)

" P16V8 Electronic Signature Word
SIGNATURE MACRO (string)
{
   @CONST cnt = 1;
   @CONST r1 = 2056;	" First address of signature word
   @IRPC A (?string)
   {
	@IF (cnt > 8) { @MESSAGE 'WORD TOO LONG'; @EXIT;}
   	FUSES [@EXPR r1;..@EXPR (r1+7);] = @EXPR '?A';;
	@CONST  r1 = r1 + 8;
	@CONST	cnt = cnt + 1;
   }
}
" P16Z8 Electronic Signature Word
SIGNATURE MACRO (string)
{
   @CONST cnt = 1;
   @CONST r1 = 2056;	" First address of signature word
   @IRPC A (?string)
   {
	@IF (cnt > 8) { @MESSAGE 'WORD TOO LONG'; @EXIT;}
   	FUSES [@EXPR r1;..@EXPR (r1+7);] = @EXPR '?A';;
	@CONST  r1 = r1 + 8;
	@CONST	cnt = cnt + 1;
   }
}
" P20V8 Electronic Signature Word
SIGNATURE MACRO (string)
{
   @CONST cnt = 1;
   @CONST r1 = 2568;	" First address of signature word
   @IRPC A (?string)
   {
	@IF (cnt > 8) { @MESSAGE 'WORD TOO LONG'; @EXIT;}
   	FUSES [@EXPR r1;..@EXPR (r1+7);] = @EXPR '?A';;
	@CONST  r1 = r1 + 8;
	@CONST	cnt = cnt + 1;
   }
}
" P22V10G Electronic Signature Word
SIGNATURE MACRO (string)
{
   @CONST cnt = 1;
   @CONST r1 = 5828;	" First address of signature word
   @IRPC A (?string)
   {
	@IF (cnt > 8) { @MESSAGE 'WORD TOO LONG'; @EXIT;}
   	FUSES [@EXPR r1;..@EXPR (r1+7);] = @EXPR '?A';;
	@CONST  r1 = r1 + 8;
	@CONST	cnt = cnt + 1;
   }
}
" P26CV12 Electronic Signature Word
SIGNATURE MACRO (string)
{
   @CONST cnt = 1;
   @CONST r1 = 6368;	" First address of signature word
   @IRPC A (?string)
   {
	@IF (cnt > 8) { @MESSAGE 'WORD TOO LONG'; @EXIT;}
   	FUSES [@EXPR r1;..@EXPR (r1+7);] = @EXPR '?A';;
	@CONST  r1 = r1 + 8;
	@CONST	cnt = cnt + 1;
   }
}
" P18V10G Electronic Signature Word
SIGNATURE MACRO (string)
{
   @CONST cnt = 1;
   @CONST r1 = 3476;	" First address of signature word
   @IRPC A (?string)
   {
	@IF (cnt > 8) { @MESSAGE 'WORD TOO LONG'; @EXIT;}
   	FUSES [@EXPR r1;..@EXPR (r1+7);] = @EXPR '?A';;
	@CONST  r1 = r1 + 8;
	@CONST	cnt = cnt + 1;
   }
}

" P29MA16.INC

	ARRAY_3   macro  { fuses [10907] = 1; };
	ARRAY_22  macro  { fuses [10915] = 1; };
	ARRAY_4   macro  { fuses [10923] = 1; };
	ARRAY_21  macro  { fuses [10931] = 1; };
	ARRAY_5   macro  { fuses [10939] = 1; };
	ARRAY_20  macro  { fuses [10948] = 1; };
	ARRAY_6   macro  { fuses [10957] = 1; };
	ARRAY_19  macro  { fuses [10966] = 1; };
	ARRAY_7   macro  { fuses [10975] = 1; };
	ARRAY_18  macro  { fuses [10984] = 1; };
	ARRAY_8   macro  { fuses [10993] = 1; };
	ARRAY_17  macro  { fuses [11002] = 1; };
	ARRAY_9   macro  { fuses [11011] = 1; };
	ARRAY_16  macro  { fuses [11019] = 1; };
	ARRAY_10  macro  { fuses [11027] = 1; };
	ARRAY_15  macro  { fuses [11035] = 1; };


" P29MA16.INC

	ARRAY_3   macro  { fuses [10327] = 1; };
	ARRAY_22  macro  { fuses [10335] = 1; };
	ARRAY_4   macro  { fuses [10343] = 1; };
	ARRAY_21  macro  { fuses [10351] = 1; };
	ARRAY_5   macro  { fuses [10359] = 1; };
	ARRAY_20  macro  { fuses [10368] = 1; };
	ARRAY_6   macro  { fuses [10377] = 1; };
	ARRAY_19  macro  { fuses [10386] = 1; };
	ARRAY_7   macro  { fuses [10395] = 1; };
	ARRAY_18  macro  { fuses [10404] = 1; };
	ARRAY_8   macro  { fuses [10413] = 1; };
	ARRAY_17  macro  { fuses [10422] = 1; };
	ARRAY_9   macro  { fuses [10431] = 1; };
	ARRAY_16  macro  { fuses [10439] = 1; };
	ARRAY_10  macro  { fuses [10447] = 1; };
	ARRAY_15  macro  { fuses [10455] = 1; };

" P330.INC
"The following select Clock 2 (pin 3) for the 
"Output Macrocell Input register.
CLK2_28 macro () {FUSES[17030] = 1;}
CLK2_27 macro () {FUSES[17034] = 1;}
CLK2_26 macro () {FUSES[17037] = 1;}
CLK2_25 macro () {FUSES[17041] = 1;}
CLK2_24 macro () {FUSES[17044] = 1;}
CLK2_23 macro () {FUSES[17048] = 1;}
CLK2_20 macro () {FUSES[17051] = 1;}
CLK2_19 macro () {FUSES[17055] = 1;}
CLK2_18 macro () {FUSES[17058] = 1;}
CLK2_17 macro () {FUSES[17062] = 1;}
CLK2_16 macro () {FUSES[17065] = 1;}
CLK2_15 macro () {FUSES[17069] = 1;}

"The following enables clock 2 (pin 3)
CLK2    macro () {FUSES[17070] = 1;}
CLK2_4  macro () {FUSES[17072] = 1;}
CLK2_5  macro () {FUSES[17073] = 1;}
CLK2_6  macro () {FUSES[17074] = 1;}
CLK2_7  macro () {FUSES[17075] = 1;}
CLK2_9  macro () {FUSES[17076] = 1;}
CLK2_10 macro () {FUSES[17077] = 1;}
CLK2_11 macro () {FUSES[17078] = 1;}
CLK2_12 macro () {FUSES[17079] = 1;}
CLK2_13 macro () {FUSES[17080] = 1;}
CLK2_14 macro () {FUSES[17081] = 1;}

"The following program the C3 bit in the Output Macrocell
"and selects feedback from the lower pin.
FEEDPIN_27 macro () {FUSES[17031] = 1;}
FEEDPIN_25 macro () {FUSES[17038] = 1;}
FEEDPIN_23 macro () {FUSES[17045] = 1;}
FEEDPIN_19 macro () {FUSES[17052] = 1;}
FEEDPIN_17 macro () {FUSES[17059] = 1;}
FEEDPIN_15 macro () {FUSES[17066] = 1;}


" P331.INC
	"The following program the C2 bit in the Output Macrocell
	"and selects feedback from the lower pin.
	FEEDPIN_27 macro () {FUSES[11906] = 1;}
	FEEDPIN_25 macro () {FUSES[11911] = 1;}
	FEEDPIN_23 macro () {FUSES[11916] = 1;}
	FEEDPIN_19 macro () {FUSES[11921] = 1;}
	FEEDPIN_17 macro () {FUSES[11926] = 1;}
	FEEDPIN_15 macro () {FUSES[11931] = 1;}

" F6001.INC

	"Input Logic Macro Cell Configuration for F6001
	" (1,1) Async Input   (default)
	" (1,0) Registered Input
	" (0,0) Latched Input
	ILMC  macro (LATCH,SYN) { FUSES [8219,8218] = [?LATCH,?SYN]; }
	IOLMC macro (LATCH,SYN) { FUSES [8221,8220] = [?LATCH,?SYN]; }

SIGNATURE MACRO (string)
{
   @CONST cnt = 1;
   @CONST r1 = 8222;	" First address of signature word
   @IRPC A (?string)
   {
	@IF (cnt > 9) { @MESSAGE 'WORD TOO LONG'; @EXIT;}
   	FUSES [@EXPR r1;..@EXPR (r1+7);] = @EXPR '?A';;
	@CONST  r1 = r1 + 8;
	@CONST	cnt = cnt + 1;
   }
}
24 
CONSTANT.INC 147 100 ""
E0320.INC 252 118 ""
E0600.INC 377 66 ""
E0900.INC 448 68 ""
E1210.INC 521 441 ""
E1800.INC 977 437 ""
F155.INC 1428 108 ""
F157.INC 1542 108 ""
F159.INC 1656 108 ""
F179.INC 1770 108 ""
F39V18.INC 8566 555 ""
F6001.INC 1884 555 ""
P16V8.INC 3433 316 ""
P16X4.INC 2460 945 ""
P16Z8.INC 3762 316 ""
P18V10G.INC 5082 318 ""
P20V8.INC 4091 316 ""
P22V10G.INC 4420 318 ""
P26CV12.INC 4751 318 ""
P29M16.INC 5413 689 ""
P29MA16.INC 6122 689 ""
P330.INC 6831 1325 ""
P331.INC 8194 361 ""
VERSION.INC 10 135 ""
